define([ 'underscore', 'backbone', 'models/connection', 'context', 'models/user'],
  function (_, Backbone, Connection, Context, User) {
    return Backbone.Collection.extend({
        model: Connection,
        url: "/connection/list",
        parse: function (res) {

          var user_id = null;

          // check if user object is passed along with connection data
          if (res.user) {
            // store user object in context
            Context.user = new User(res.user);
          }

          // context user can be set previously without res.user being present
          if (Context.user) {
            user_id = Context.user.get("id");
          }

          // parse connections and add is_owner property
          return _.map(res.connections, function (conn) {
            conn.is_owner = conn.user_id === user_id;
            return conn;
          });
        }
    });
});
