// Filename: main.js

require.config({
    waitSeconds: 0,
    paths: {
        jquery: "bower_components/jquery/dist/jquery.min",
        underscore: "bower_components/lodash/lodash.min",
        backbone: "bower_components/backbone/backbone",
        text: "bower_components/requirejs-text/text",
        handlebars: "bower_components/handlebars/handlebars.min",
        squel: "lib/squel.patched",
        bootstrap: "bower_components/bootstrap/dist/js/bootstrap",
        sprintf: "bower_components/sprintf.js/src/sprintf.min",
        d3: "bower_components/d3/d3.min",
        c3: "bower_components/c3/c3",
        tpls: "build/templates",
        tabs: "bower_components/jquery-too-many-tabs/toomanytabs",
        grid: "bower_components/sensei-grid/dist/sensei-grid",
        rowactions: "bower_components/sensei-grid/src/sensei-row-actions",
        anywhere: "bower_components/sensei-anywhere/src/sensei-anywhere",
        cm: "bower_components/codemirror",
        mousetrap: "bower_components/mousetrap/mousetrap.min",
        cookiesjs: "bower_components/cookies-js/dist/cookies",
        moment: "bower_components/moment/min/moment.min",
        inview: "bower_components/isInViewport/lib/isInViewport.min",
        pickadate: "bower_components/sensei-grid/lib/pickadate/lib/picker",
        pickadate_date: "bower_components/sensei-grid/lib/pickadate/lib/picker.date",
        typeahead: "bower_components/typeahead.js/dist/typeahead.jquery"
    },
    shim: {
        handlebars: {exports: 'Handlebars'},
        cm: {exports: 'CodeMirror'},
        d3: {exports: 'd3'},
        c3: {deps: ['d3'], exports: 'c3'},
        bootstrap: {deps: ['jquery']},
        typeahead: {deps: ['jquery']},
        pickadate_date: ["pickadate"],
        grid: {deps: ['jquery', 'underscore', "pickadate_date"]},
        anywhere: {deps: ['jquery', 'underscore', 'mousetrap']},
        sqlparser: {exports: "SQLParser"}
    }
});

define(["jquery", "underscore", "backbone", "router", "views/app", "events", "cookiesjs",
        "helpers/csfr", "helpers/string", "helpers/handlebars",
        "helpers/dropdown-fix", "bootstrap"],
    function ($, _, Backbone, Router, MainApp, Events, Cookies) {
        var app = new MainApp();
        app.render();

        Router.initialize();

        $(window).on('beforeunload', function() {
          Cookies.set("last_url", Backbone.history.getFragment());
        });

        // global event logger
        Events.on("all", function(event, arg) {
            console.info("[event]", event);
        });
    });
