define(['underscore', 'backbone', 'context'], function (_, Backbone, Context) {
    var Table = Backbone.Model.extend({
        methodUrl: {
            'create': "/schema/table/%(connection)s/%(db)s",
            'update': "/schema/table/rename/%(connection)s/%(db)s/%(rename_from)s",
            'delete': '/schema/table/%(connection)s/%(db)s/%(model_table)s'
        },
        // url: function () {
        //     if (this.get("rename_from")) {
        //         Context.rename_from = this.get("rename_from");
        //         return "/schema/table/rename/%(connection)s/%(db)s/%(rename_from)s".format(Context);   
        //     }
        //     return "/schema/table/create/%(connection)s/%(db)s".format(Context);
        // },
        idAttribute: "title",
        parse: function (res) {
            if (_.isString(res)) {
                this.set('title', res);        		
            }
        },
        sync: function(method, model, options) {
            method = method.toLowerCase();
            if (model.methodUrl && model.methodUrl[method]) {
                options = options || {};
                Context.model_table = this.get("title");
                Context.rename_from = this.get("rename_from"); // could this be gotten from prev_attributes or similar builtin

                // workaround because tables do not have uniqid, we are using title and rename_from instead
                if (this.get("title") && !this.get("rename_from") && method === "update") {
                    method = "create";
                }

                options.url = model.methodUrl[method].format(Context);
            }
            Backbone.sync(method, model, options);
        }
    });
    return Table;
});